# kio Library API Documentation

Overview | Class Hierarchy | Classes | Classes (annotated) | Members | Namespaces | Source Files

# KURLCompletion Class Reference

This class does completion of URLs including user directories (~user) and environment variables. Completion of a single URL. More...

`#include <kurlcompletion.h>`

Inheritance diagram for KURLCompletion:

[legend]
Collaboration diagram for KURLCompletion:

[legend]
List of all members.

## Public Types

enum | Mode { ExeCompletion = 1, FileCompletion, DirCompletion }

## Public Member Functions

| KURLCompletion ()
| KURLCompletion (Mode)
virtual | ~KURLCompletion ()
virtual QString | makeCompletion (const QString &text)
virtual void | setDir (const QString &dir)
virtual QString | dir () const
virtual bool | isRunning () const
virtual void | stop ()
virtual Mode | mode () const
virtual void | setMode (Mode mode)
virtual bool | replaceEnv () const
virtual void | setReplaceEnv (bool replace)
virtual bool | replaceHome () const
virtual void | setReplaceHome (bool replace)
QString | replacedPath (const QString &text)

## Static Public Member Functions

static QString | replacedPath (const QString &text, bool replaceHome, bool replaceEnv=true)

## Protected Slots

void | slotEntries (KIO::Job *, const KIO::UDSEntryList &)
void | slotIOFinished (KIO::Job *)

## Protected Member Functions

void | postProcessMatch (QString *match) const
void | postProcessMatches (QStringList *matches) const
void | postProcessMatches (KCompletionMatches *matches) const
virtual void | customEvent (QCustomEvent *e)
virtual void | virtual_hook (int id, void *data)

## Detailed Description

This class does completion of URLs including user directories (~user) and environment variables. Completion of a single URL.

Remote URLs are passed to KIO.

Author:
  David Smith <dsmith@algonet.se>

Definition at line 41 of file kurlcompletion.h.

## Member Enumeration Documentation

enum KURLCompletion::Mode

Determines how completion is done.

- ExeCompletion - executables in $PATH or with full path.
- FileCompletion - all files with full path or in dir(), URLs are listed using KIO.
- DirCompletion - Same as FileCompletion but only returns directories.

Definition at line 53 of file kurlcompletion.h.

## Constructor & Destructor Documentation

KURLCompletion::KURLCompletion | ( |  | ) |

| Constructs a KURLCompletion object in FileCompletion mode. Definition at line 478 of file kurlcompletion.cpp.

KURLCompletion::KURLCompletion | ( | Mode |  | ) |

| This overloaded constructor allows you to set the Mode to ExeCompletion or FileCompletion without using setMode. Default is FileCompletion. Definition at line 484 of file kurlcompletion.cpp. References setMode().

KURLCompletion::~KURLCompletion | ( |  | ) | `[virtual]`

| Destructs the KURLCompletion object. Definition at line 490 of file kurlcompletion.cpp. References stop().

## Member Function Documentation

QString KURLCompletion::makeCompletion | ( | const QString & | text | ) | `[virtual]`

Finds completions to the given text.

Remote URLs are listed with KIO. For performance reasons, local files are listed with KIO only if KURLCOMPLETION_LOCAL_KIO is set. The completion is done asyncronously if KIO is used.

Returns the first match for user, environment, and local dir completion and QString::null for asynchronous completion (KIO or threaded).

Parameters:

  | text | the text to complete

Returns:
  the first match, or QString::null if not found

Reimplemented from KCompletion.

Reimplemented in KShellCompletion.

Definition at line 564 of file kurlcompletion.cpp.

References QString::left(), QString::length(), QString::prepend(), QString::ref(), and stop().

Referenced by KShellCompletion::makeCompletion().

void KURLCompletion::setDir | ( | const QString & | dir | ) | `[virtual]`

Sets the current directory (used as base for completion).

Default = $HOME.

Parameters:

  | dir | the current directory, either as a path or URL

Definition at line 519 of file kurlcompletion.cpp.

Referenced by KFileDialog::init().

QString KURLCompletion::dir | ( |  | ) | const`[virtual]`

Returns the current directory, as it was given in setDir.

Returns:
  the current directory (path or URL)

Definition at line 524 of file kurlcompletion.cpp.

bool KURLCompletion::isRunning | ( |  | ) | const`[virtual]`

Check whether asynchronous completion is in progress.

Returns:
  true if asynchronous completion is in progress

Definition at line 650 of file kurlcompletion.cpp.

void KURLCompletion::stop | ( |  | ) | `[virtual]`

| Stops asynchronous completion. Definition at line 660 of file kurlcompletion.cpp. References QString::isEmpty(). Referenced by makeCompletion(), and ~KURLCompletion().

KURLCompletion::Mode KURLCompletion::mode | ( |  | ) | const`[virtual]`

Returns the completion mode: exe or file completion (default FileCompletion).

Returns:
  the completion mode

Definition at line 529 of file kurlcompletion.cpp.

void KURLCompletion::setMode | ( | Mode | mode | ) | `[virtual]`

Changes the completion mode: exe or file completion.

Parameters:

  | mode | the new completion mode

Definition at line 534 of file kurlcompletion.cpp.

Referenced by KDirSelectDialog::KDirSelectDialog(), KURLCompletion(), and KShellCompletion::makeCompletion().

bool KURLCompletion::replaceEnv | ( |  | ) | const`[virtual]`

Checks whether environment variables are completed and whether they are replaced internally while finding completions.

Default is enabled.

Returns:
  true if environment vvariables will be replaced

Definition at line 539 of file kurlcompletion.cpp.

void KURLCompletion::setReplaceEnv | ( | bool | replace | ) | `[virtual]`

Enables/disables completion and replacement (internally) of environment variables in URLs.

Default is enabled.

Parameters:

  | replace | true to replace environment variables

Definition at line 544 of file kurlcompletion.cpp.

bool KURLCompletion::replaceHome | ( |  | ) | const`[virtual]`

Returns whether ~username is completed and whether ~username is replaced internally with the user's home directory while finding completions.

Default is enabled.

Returns:
  true to replace tilde with the home directory

Definition at line 549 of file kurlcompletion.cpp.

void KURLCompletion::setReplaceHome | ( | bool | replace | ) | `[virtual]`

Enables/disables completion of ~username and replacement (internally) of ~username with the user's home directory.

Default is enabled.

Parameters:

  | replace | true to replace tilde with the home directory

Definition at line 554 of file kurlcompletion.cpp.

QString KURLCompletion::replacedPath | ( | const QString & | text | ) |

Replaces username and/or environment variables, depending on the current settings and returns the filtered url.

Only works with local files, i.e. returns back the original string for non-local urls.

Parameters:

  | text | the text to process

Returns:
  the path or URL resulting from this operation. If you want to convert it to a KURL, use KURL::fromPathOrURL.

Definition at line 1365 of file kurlcompletion.cpp.

The documentation for this class was generated from the following files:

- kurlcompletion.h
- kurlcompletion.cpp

This file is part of the documentation for kio Library Version 3.4.1.
Documentation copyright © 1996-2004 the KDE developers.
Generated on Sat Jun 11 20:25:43 2005 by doxygen 1.4.1 written by Dimitri van Heesch, © 1997-2003